#include "wsp.h"
#include "jpeg.h"
#define WIDTH 640
#define HEIGHT 480

BMP bmp,bmp4;

int wsInit()
{
	int i,j;
	INSTALL(GDI);
	INSTALL(KEY);
	WSP::display(WIDTH,HEIGHT);
	init_jpeg();
	bmp.load_bitmap("back.jpg");
	bmp4.create(WIDTH/2,HEIGHT/2);
	for (i=0;i<HEIGHT;i+=2)
		for (j=0;j<WIDTH;j+=2) {
			int red,green,blue;
			PIXEL a,b,c,d;
			a=bmp.bmp->line[i][j];
			b=bmp.bmp->line[i][j+1];
			c=bmp.bmp->line[i+1][j];
			d=bmp.bmp->line[i+1][j+1];
			red=(a.red()+b.red()+c.red()+d.red())/4;
			green=(a.green()+b.green()+c.green()+d.green())/4;
			blue=(a.blue()+b.blue()+c.blue()+d.blue())/4;
			bmp4.bmp->line[i/2][j/2].set(red,green,blue);
		}
	return 0;
}

void sblit(int w)
{
	int w1,w2,i,j,h1,h2,h;
	int x1,y1,x2,y2,s;
	PIXEL *p;
	h=w*HEIGHT/WIDTH;
	w1=256*WIDTH/w;
	w2=256*WIDTH/2/w;
	h1=256*HEIGHT/h;
	h2=256*HEIGHT/2/h;
	s=(w*4*32/WIDTH-32)/3;
	for (y1=0,y2=0,i=0;i<h;i++,y1+=h1,y2+=h2) {
		p=screen.bmp->line[i];
		for (x1=0,x2=0,j=0;j<w;j++,x1+=w1,x2+=w2,p++) {
			PIXEL p1,p2;
			p1=bmp.bmp->line[y1>>8][x1>>8];
			p2=bmp4.bmp->line[y2>>8][x2>>8];
			__asm {
				mov ax,p1;
				mov bx,p2;
				shl eax,16;
				shl ebx,16;
				mov ax,p1;
				mov bx,p2;
				and eax,0x3e07c1f// 11111 00000 0 11111 00000 11111
				and ebx,0x3e07c1f
				xor edx,edx
				sub eax,ebx
				mul s
				shr eax,5
				add eax,ebx
				mov ebx,p
				and eax,0x3e07c1f
				mov edx,eax
				shr eax,16
				or eax,edx
				mov [ebx],ax
//				mov p1,ax
			}
		}
//			red=(p1.red()*s+p2.red()*(32-s))>>5;
//			green=(p1.green()*s+p2.green()*(32-s))>>5;
//			blue=(p1.blue()*s+p2.blue()*(32-s))>>5;
//			screen.bmp->line[i][j].set(red,green,blue);
//			screen.bmp->line[i][j]=p1;
		}

}

int wsMain()
{
	static i=WIDTH/2*4,speed=4;
//	bmp.blit(screen,0,0,0,0,200,200);
//	bmp4.blit(screen,0,0,0,0,100,100);
	sblit(i/4);
	screen.printf(0,0,0xffffff,"%d",i/4);
	i+=speed,++speed;
	if (i>WIDTH*4) i=WIDTH/2*4,speed=4;
	WSP::update();
	return 0;
}

void wsExit()
{
}

